// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.internal.component.AbstractUIConfig;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Renders a UIComponent for configurations applied in the browser.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ConfigTagDeclaration}.
 */
@Generated("component.stg")
public class UIConfig
    extends AbstractUIConfig  {

  private static final Tags TAG = Tags.config;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Output";


  enum PropertyKeys {
    waitOverlayDelayAjax,
    focusOnError,
    waitOverlayDelayFull,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  The delay before a AJAX request will get an overlay.

  */
  public java.lang.Integer getWaitOverlayDelayAjax() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.waitOverlayDelayAjax);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setWaitOverlayDelayAjax(java.lang.Integer waitOverlayDelayAjax) {
    getStateHelper().put(PropertyKeys.waitOverlayDelayAjax, waitOverlayDelayAjax);
  }

  /**
  Should the focus set to first error on page.

  */
  public Boolean getFocusOnError() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.focusOnError);
    if (bool != null) {
      return bool;
    }
    return null;
  }

  public void setFocusOnError(Boolean focusOnError) {
    getStateHelper().put(PropertyKeys.focusOnError, focusOnError);
  }

  /**
  The delay before a full request will get an overlay.

  */
  public java.lang.Integer getWaitOverlayDelayFull() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.waitOverlayDelayFull);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setWaitOverlayDelayFull(java.lang.Integer waitOverlayDelayFull) {
    getStateHelper().put(PropertyKeys.waitOverlayDelayFull, waitOverlayDelayFull);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}